#include "SocketS.h"



DWORD WINAPI SocketS::ThreadProc(LPVOID lpParameter)
{
	SocketS* server = (SocketS*)lpParameter;
	HANDLE port = server->hPort;
	DWORD NumberOfBytes;
	ULONG_PTR index;
	LPOVERLAPPED lpOverlapped;

	while (server->g_flag)
	{
		BOOL bFlag = GetQueuedCompletionStatus(port, &NumberOfBytes, &index, &lpOverlapped, INFINITE);
		if (FALSE == bFlag)
		{
			if (64 == GetLastError())
			{
				printf("ͻ쳣\n");
				msgInfo* info = new msgInfo;
				info->index = index;
				info->len = -1;
				server->msgLock.lock();
				server->msgList.push_back(info);
				server->msgLock.unlock();
			}
			continue;
		}

		// ദ

		if (0 == index)	// accept
		{
			printf("accept\n");
			// 󶨵ɶ˿
			HANDLE hPort1 = CreateIoCompletionPort((HANDLE)server->ClienMap[server->g_count].c_Sock, port, server->g_count, 0);
			if (hPort1 != port)
			{
				printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
				closesocket(server->ClienMap[server->g_count].c_Sock);
				continue;
			}
			server->PostRecv(server->g_count);	// Ͷrecv
			++server->g_count;			// ͻ++
			server->PostAccept();		// Ͷaccept
		}
		else
		{
			if (0 == NumberOfBytes)
			{
				printf("ͻ\n");

				closesocket(server->ClienMap[index].c_Sock);
				WSACloseEvent(server->ClienMap[index].c_Olp.hEvent);
				// ɾ
				server->ClienMap[index].c_Sock = 0;
				server->ClienMap[index].c_Olp.hEvent = NULL;
				server->ClienMap.erase(index);

				msgInfo* info = new msgInfo;
				info->index = index;
				info->len = -1;
				server->msgLock.lock();
				server->msgList.push_back(info);
				server->msgLock.unlock();
			}
			else
			{
				if (0 != server->ClienMap[index].c_strRecv)	// recv
				{
					// յͻϢ 
					msgInfo* info = new msgInfo;
					info->index = index;
					info->len = NumberOfBytes;
					memcpy_s(info->buf, NumberOfBytes, server->ClienMap[index].c_strRecv, NumberOfBytes);

					server->msgLock.lock();
					server->msgList.push_back(info);
					server->msgLock.unlock();

					memset(server->ClienMap[index].c_strRecv, 0, sizeof(server->ClienMap[index].c_strRecv));
					server->PostRecv(index);	// ԼͶݽ
				}
			}
		}
	}

	return 0;
}


SocketS::SocketS()
{
}


int SocketS::PostAccept(void)
{
	ClienMap[g_count].c_Sock = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);
	ClienMap[g_count].c_Olp.hEvent = WSACreateEvent();

	char str[1024] = { 0 };
	DWORD dwRecvcount;
	AcceptEx(ClienMap[0].c_Sock, ClienMap[g_count].c_Sock, str, 0, sizeof(struct sockaddr_in) + 16, sizeof(struct sockaddr_in) + 16, &dwRecvcount, &ClienMap[0].c_Olp);

	if (ERROR_IO_PENDING != WSAGetLastError())
	{
		return 1;	// ִг
	}
	return 0;
}

int SocketS::PostRecv(int index)
{
	WSABUF wsabuf;
	wsabuf.buf = ClienMap[index].c_strRecv;
	wsabuf.len = 1024;

	DWORD dwRecvCount;
	DWORD dwFlag = 0;
	WSARecv(ClienMap[index].c_Sock, &wsabuf, 1, &dwRecvCount, &dwFlag, &ClienMap[index].c_Olp, NULL);

	if (ERROR_IO_PENDING != WSAGetLastError())
	{
		return 1;	// ִг
	}
	return 0;
}

int SocketS::PostSend(int index, const char* buf, int len)
{
	
	if (ClienMap.find(index) != ClienMap.end())
	{
		if (ClienMap[index].c_Sock != 0)
		{
			return send(ClienMap[index].c_Sock, buf, len, 0);
		}
	}
	return 0;
}

BOOL SocketS::Creat(int Prot)
{
	// 
	WORD wVersionRequird = MAKEWORD(2, 2);	// MAKEWORD(汾,汾)
	WSADATA wdScokMsg;
	switch (WSAStartup(wVersionRequird, &wdScokMsg))
	{
	case WSASYSNOTREADY:
		printf("ԣ߼\n");
		return -1;

	case WSAVERNOTSUPPORTED:
		printf("\n");
		return -1;

	case WSAEPROCLIM:
		printf("볢ԹصҪΪǰṩԴ\n");
		return -1;

	case WSAEINPROGRESS:
		printf("\n");
		return -1;
	}

	// У汾
	if (2 != HIBYTE(wdScokMsg.wVersion) || 2 != LOBYTE(wdScokMsg.wVersion))
	{
		printf("汾\n");
		WSACleanup();
		return -1;
	}

	// socket
	SOCKET socketServer = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);
	if (INVALID_SOCKET == socketServer)
	{
		printf("WSASocketʧ error:%d\n", WSAGetLastError());
		WSACleanup();
		return -1;
	}

	// 󶨵ַ
	SOCKADDR_IN sockAddress;
	sockAddress.sin_family = AF_INET;
	sockAddress.sin_addr.S_un.S_addr = htonl(INADDR_ANY);	// INADDR_ANY --- κεַ
	sockAddress.sin_port = htons(Prot);
	if (SOCKET_ERROR == bind(socketServer, (struct sockaddr*)&sockAddress, sizeof(sockAddress)))
	{
		printf("bind ʧ error:%d\n", WSAGetLastError());
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	ClienMap[g_count].c_Sock = socketServer;
	ClienMap[g_count].c_Olp.hEvent = WSACreateEvent();
	++g_count;

	// ɶ˿
	hPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0);
	if (NULL == hPort)
	{
		printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	// 󶨶˿SOCKET
	HANDLE hPort1 = CreateIoCompletionPort((HANDLE)socketServer, hPort, 0, 0);
	if (hPort1 != hPort)
	{
		printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
		CloseHandle(hPort);
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	// ʼ
	if (SOCKET_ERROR == listen(socketServer, SOMAXCONN))
	{
		printf("listen ʧ error:%d\n", WSAGetLastError());
		CloseHandle(hPort);
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	if (0 != PostAccept())
	{
		Clear();
		WSACleanup();
		return -1;
	}

	// ȡҪ߳
	SYSTEM_INFO systemProcessorsCount;
	GetSystemInfo(&systemProcessorsCount);
	int nProcessorsCount = systemProcessorsCount.dwNumberOfProcessors;
	g_flag = TRUE;
	// ߳
	pThread = (HANDLE*)malloc(sizeof(HANDLE) * nProcessorsCount);
	for (int i = 0; i < nProcessorsCount; ++i)
	{
		pThread[i] = CreateThread(NULL, 0, ThreadProc, (LPVOID)this, 0, NULL);
		if (NULL == pThread[i])
		{
			printf("CreateThread ʧ error:%d\n", WSAGetLastError());
			CloseHandle(hPort);
			closesocket(socketServer);
			WSACleanup();
			return -1;
		}
	}

}

void SocketS::Clear()
{
	g_flag = FALSE;
	for (auto i = ClienMap.begin(); i != ClienMap.end(); ++i)
	{
		if (0 == i->second.c_Sock)
		{
			continue;
		}
		closesocket(i->second.c_Sock);
		WSACloseEvent(i->second.c_Olp.hEvent);
	}
	ClienMap.clear();

	free(pThread);
	CloseHandle(hPort);
	WSACleanup();
}

SocketS::msgInfo* SocketS::GetMsg()
{
	msgInfo* info = NULL;
	msgLock.lock();
	if (msgList.size() > 0)
	{
		info = *msgList.begin();
		msgList.pop_front();
	}
	msgLock.unlock();
	return info;
}
