#pragma once
#define WIN32_LEAN_AND_MEAN

#include <stdio.h>
#include <stdlib.h>
#include <Windows.h>
#include <WinSock2.h>
#include <mswsock.h>
#include <map>
#include <string>
#include <list>
#include <mutex>

#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "Mswsock.lib")

class SocketS
{
public:
	struct msgInfo
	{
		int index;
		int len = 0;
		char buf[1025] = { 0 };
	};

private:
	struct clienInfo
	{
		SOCKET c_Sock;
		OVERLAPPED c_Olp;
		char c_strRecv[1024];
	};

	BOOL g_flag = TRUE;			//״̬
	HANDLE hPort = NULL;		//ɶ˿ھ
	HANDLE* pThread = NULL;		//߳̾
	int g_count = 0;			//ǰͻID	
	std::map<int, clienInfo>ClienMap;	//пͻ

	std::mutex msgLock;				//Ϣ
	std::list<msgInfo*>msgList;			//Ϣ
	static DWORD WINAPI ThreadProc(LPVOID lpParameter);		//߳

public:
	SocketS();
	int PostAccept(void);
	int PostRecv(int index);
	int PostSend(int index, const char* buf, int len);
	BOOL Creat(int Prot);
	void Clear();
	msgInfo* GetMsg();
};

